<?php
//  Synopsis:    Calls html-tidy to reformat xml file
//  Author:      Dirk Henrici
//  Created:     2005-11-09
//  Last update: 2005-11-24
//  Comment:     Requires php5, html-tidy

  global $tidycommand, $xmldir;
  $tidycommand = 'tidy -quiet -indent -wrap 150 -xml -modify';

  // Beautify specified xml-file
  function WebPresenter_BeautifyXML($file) {
    global $tidycommand;
    //HTML-Tidy zur Formatierung aufrufen
    passthru($tidycommand. ' '. escapeshellarg($file), $errcode);
    if ($errcode==0) {
      echo 'XML-Neuformatierung: Verarbeitung der Datei [...'. basename(dirname($file)) . '/'. basename($file). "] erfolgreich abgeschlossen.\n";
    } else {
      echo "  Fehler: Tidy lieferte Fehler [$errcode] zurck.\n";
      echo "Fehler bei XML-Neuformatierung: Neuformatierung der Datei [$file] abgebrochen.\n";
    }    
  } 

  // Beautify all xml-files in directory $xmldir
  function WebPresenter_BeautifyXMLDir() {
    global $xmldir;
    if (($dir = realpath($xmldir)) and (is_dir($dir))) {
      $files = scandir($dir);
      foreach ($files as $file) {
        $extpos = strrpos($file, '.');
        $ext = '';
        if (!($extpos===false))
          $ext = substr($file, $extpos);
        if ($ext == '.xml')
          WebPresenter_BeautifyXML($dir. '/'. $file);
      }
    } else {
      echo "Beautify XML Directory: Fehler: Verzeichnis [$xmldir] existiert nicht.\n";
    }
  }
?>
