<?php
//  Synopsis:    Creates a list of slides and aranges slides anew
//  Author:      Dirk Henrici
//  Created:     2005-11-08
//  Last update: 2005-12-07
//  Comment:     Requires php5

  global $standard_frame, $outputdir;
  $standard_frame = 'Daten';  
  $outputdir = './extracted/';
  $appendtitle = true;

  function GetFilenameBeginningWith($filedir, $fileinfo) {
    if ($fileinfo=='')
      return $fileinfo;
    $filedir = scandir($filedir);
    foreach ($filedir as $currentfile)
      if (substr($currentfile, 0, strlen($fileinfo))==$fileinfo) {
        $zw = strpos($currentfile, '.');
        if (!($zw===false))
          $currentfile = substr($currentfile, 0, $zw);
        return $currentfile;
      }
    return $fileinfo;
  }

  function WebPresenter_ExtractSlides($file, &$doc) {
    global $standard_frame, $outputdir, $appendtitle;

    echo "Folien-Extraktion: Beginn der Verarbeitung von Datei [$file]...\n";

    if (!is_dir($outputdir))
      mkdir($outputdir);

    $success = true;
    $lastuserinput = '';
    $xpath = new DOMXPath($doc);
    $xpath->registerNamespace('icsy', $doc->documentElement->namespaceURI);
    $slides = $xpath->query('//icsy:lecture/topic/slide', $doc);
    foreach ($slides as $slidenode) {
      //Quell-URL der Folie ermitteln
      $nodes = $xpath->query('media/link[1]/frame[@name="'. $standard_frame. '"]', $slidenode); //Index 0 gibt es nach W3C in xpath nicht
      if ($nodes->length==0)
        $nodes = $xpath->query('media/link[1]', $slidenode);
      if ($nodes->length!=0)
        $media_url = $nodes->item(0)->getAttribute('url');
      //Folientitel auslesen
      $zw = $xpath->query('metadata/content/title[1]', $slidenode);
      if ($zw->length > 0)
        $title = $zw->item(0)->nodeValue;
      //Benutzer fragen, was mit Folie passieren soll
      $validinput = false;
      $default = '';
      if (!empty($media_url)) {
        $default = basename($media_url);
        $zw = strpos($default, '.');
        if (!($zw===false)) 
          $default = substr($default, 0, $zw);
      }
      do {
        $userinput = readline("  Slide [{$slidenode->getAttribute('id')}: $title] - ('/':skip, 'l':last) [$default]: ");
        if ($userinput=='/') {
          $validinput = true;
        } else {
          if (strtolower($userinput)=='l')
            $userinput = $lastuserinput;
          $expandedinput = GetFilenameBeginningWith($outputdir, $userinput);
          if ($userinput != $expandedinput) {
            $default = $expandedinput;
          } else {
            if (empty($userinput))
              $userinput = $default;
            if (!empty($userinput))
              $validinput = true;
          }
        }
      } while (!$validinput);
      if ($userinput!='/') {
        //Ziel-XML-Datei laden bzw. neu erstellen
        $destdoc = new domDocument;
        if (file_exists($outputdir. $userinput. '.xml')) {
          $destdoc->load($outputdir. $userinput. '.xml');
        } else {
//          $newnode = $destdoc->createElement('lecture');
//          $newnode = $destdoc->importNode($doc->documentElement, false); //Root-Node kopieren - kopiert leider Schema-Info/Namespaces nicht mit
          $newnode = $destdoc->createElementNS($doc->documentElement->namespaceURI, $doc->documentElement->prefix. ':lecture');
          $newnode->setAttribute('xmlns:xsi', $doc->documentElement->lookupNamespaceURI('xsi'));
          foreach ($doc->documentElement->attributes as $attribute)
            $newnode->setAttribute($attribute->prefix. ':'. $attribute->name, $attribute->value);
          $destdoc->appendChild($newnode);
          $newtopic = $destdoc->createElement('topic');
          $newnode->appendChild($newtopic);
          //niedrigste Presentation-Metadaten kopieren
          $nodes = $xpath->query('metadata/presentation[1]', $slidenode);
          if ($nodes->length==0)
            $nodes = $xpath->query('metadata/presentation[1]', $slidenode->parentNode);
//            $nodes = $xpath->query('//icsy:lecture/topic/metadata/presentation[1]', $doc); // Nicht korrekt, wenn mehrere Topics in XML-Datei
          if ($nodes->length==0)
            $nodes = $xpath->query('metadata/presentation[1]', $slidenode->parentNode->parentNode);
//            $nodes = $xpath->query('//icsy:lecture/metadata/presentation[1]', $doc);
          if ($nodes->length!=0) {
            $newmetadata = $destdoc->createElement('metadata');
            $newtopic->appendChild($newmetadata);
            $newnode = $destdoc->importNode($nodes->item(0), true);
            $newmetadata->appendChild($newnode);
          }
        }
        //Prfen, ob Slide in Zieldatei bereits existiert
        $destxpath = new DOMXPath($destdoc);
        $destxpath->registerNamespace('icsy', $doc->documentElement->namespaceURI);
        $nodes = $destxpath->query('//icsy:lecture/topic[1]/slide[@id="'. $slidenode->getAttribute('id'). '"]', $destdoc);
        if ($nodes->length != 0) {
          echo "  Warnung: Folie existiert bereits in Zieldatei und wird daher bergangen.\n";
        } else {
          //Folie in Zieldatei anfgen
          $nodes = $destxpath->query('//icsy:lecture/topic[1]', $destdoc); //Index 0 gibt es nach W3C in xpath nicht
          if ($nodes->length == 0) {
            echo '  Fehler: ['. $outputdir. $userinput. ".xml ] hat keinen gltigen Aufbau.\n";
          } else {
            $newnode = $destdoc->importNode($slidenode, true);
            $nodes->item(0)->appendChild($newnode);
            //Mediendateien ins Zielverzeichnis kopieren
            $nodes = $destxpath->query('media/*', $newnode);
            foreach ($nodes as $currentnode) {
              $filename = $currentnode->getAttribute('filename');              
              if (!empty($filename)) {
                $destfilename = $outputdir. basename($filename);
                //Neuen Dateinamen ggf. an Mediendateien anfgen
                if ($appendtitle) {
                  $extpos = strrpos($destfilename, '.');
                  $destfilename = substr($destfilename, 0, $extpos). '_'. $userinput. substr($destfilename, $extpos);
                  $currentnode->setAttribute('filename', basename($destfilename));
                }
                //Mediendateien ins Zielverzeichnis kopieren
                if (!@copy(dirname($file). '/'. $filename, $destfilename))
                  echo "  Fehler:  Eine Mediendatei [$filename] konnte nicht ins Zielverzeichnis kopiert werden.\n";
              }
            }
            //Gendertes Zielfile speichern
            $destdoc->save($outputdir. $userinput. '.xml');
          }
        }
        $lastuserinput = $userinput;
      }
    }
    if ($success) echo "Verarbeitung der Datei [$file] ohne Fehler abgeschlossen.\n";

    return $success;
  } 
?>
