package eLecture;

import eLecture.annotation.Annotation;

/**
 * @author seb
 *
 * wrap information provided by a slide element of the XML input file.
 */
public class Slide {

	/**
	 * duration of slide
	 */
	private long duration;
	/**
	 * canvas width of slide
	 */
	private int width;
	/**
	 * canvas height of slide
	 */
	private int height;
	/**
	 * point of start
	 */
	private long start;
	
	private String imageUrl;
	private String placeholderUrl;
	private String audioUrl;
	private String sourceUrl;
	/**
	 * list of annotations of slide (freehand, textmarker, textbox or laserpointer)
	 */
	private Annotation[] annotations;
	/**
	 * slide's metadata. can be null if no data is available
	 */
	private Metadata metadata;
	
	public Slide(String image, String snapshot, String audio, String url,
			Annotation[] annotations, long duration, int width, int height,
			Metadata metadata) {
		imageUrl = image;
		placeholderUrl = snapshot; 
		audioUrl = audio;
		sourceUrl = url;
		this.annotations = annotations;
		this.duration = duration;
		this.width = width;
		this.height = height;
		this.metadata = metadata;
	}

	public Annotation[] getAnnotations() {
		return annotations;
	}

	public String getAudioUrl() {
		return audioUrl;
	}

	public long getDuration() {
		return duration;
	}

	public int getHeight() {
		return height;
	}

	public String getImageUrl() {
		return imageUrl;
	}

	public String getPlaceholderUrl() {
		return placeholderUrl;
	}

	public String getSourceUrl() {
		return sourceUrl;
	}

	public int getWidth() {
		return width;
	}	
	
	public void setStart(long start) {
		this.start = start;
	}
	
	public long getStart() {
		return start;
	}

	public Metadata getMetadata() {
		return metadata;
	}
}
