package eLecture.annotation;

import eLecture.Location;

/**
 * @author seb
 * 
 * Concrete <code>Annotation</code>. Class represents a textmarker. 
 * <code>duration</code>, <code>x</code>, <code>y</code>, <code>offsetx</code> and 
 * <code>offsety</code> are extra attributes of a textmarker.
 * 
 */
public class Rectangle extends Annotation {
	long duration;
	int x;
	int y;
	int offsetx;
	int offsety;
	
	public Rectangle(long timestamp, String color, String transparency, 
			Location[] locations, long duration, int x, int y, 
			int offsetx, int offsety) { 
		super(timestamp, color, transparency, locations);
		this.duration = duration;
		this.x = x;
		this.y = y;
		this.offsetx = offsetx;
		this.offsety = offsety;
	}
	
	public long getDuration() {
		return duration;
	}

	public int getOffsetx() {
		return offsetx;
	}

	public int getOffsety() {
		return offsety;
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}
}

