package eLecture.annotation;

/**
 * @author seb
 * 
 * Concrete <code>Annotation</code>. Class represents a texbox. 
 * 
 */
public class Textbox extends Annotation {
	private long duration;
	private String preferredFont;
	private String fontStyle;
	private double fontSize;
	private String textColor;
	private int x, y, connectX, connectY;
	private int width, height;
	private String[] lines;
	private String fillType;
	
	public Textbox(long timestamp, long duration, String fontFamily, String 
			fontStyle, double fontSize, String bgColor, String textColor, int x, 
			int y, int connectX, int connectY, int width, int height, String 
			transparency, String[] lines, String fillType) {
			super(timestamp, bgColor, transparency, null);
		this.duration = duration;
		this.preferredFont = fontFamily;
		this.fontStyle = fontStyle;
		this.fontSize = fontSize;
		this.textColor = textColor;
		this.x = x;
		this.y = y;
		this.connectX = connectX;
		this.connectY = connectY;
		this.width = width;
		this.height = height;
		this.lines = lines;
		this.fillType = fillType;
	}

	public int getConnectX() {
		return connectX;
	}

	public int getConnectY() {
		return connectY;
	}

	public long getDuration() {
		return duration;
	}

	public double getFontSize() {
		return fontSize;
	}

	public String getFontStyle() {
		return fontStyle;
	}

	public int getHeight() {
		return height;
	}
	
	public String getPreferredFont() {
		return preferredFont;
	}

	public String[] getLines() {
		return lines;
	}

	public String getTextColor() {
		return textColor;
	}

	public int getWidth() {
		return width;
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	public String getFillType() {
		return fillType;
	}
}
